[LeetCode] 160. Intersection of Two Linked Lists

题目链接:传送门

Description

Write a program to find the node at which the intersection of two singly linked lists begins.


For example, the following two linked lists:

A:          a1 → a2

c1 → c2 → c3

B: b1 → b2 → b3

begin to intersect at node c1.


Notes:

  • If the two linked lists have no intersection at all, return null.
  • The linked lists must retain their original structure after the function returns.
  • You may assume there are no cycles anywhere in the entire linked structure.
  • Your code should preferably run in O(n) time and use only O(1) memory.

Solution

题意:

求两个单链表的交集的起点

notice:不能改变链表的结构

思路:

懵懵的看了Discuss / Solution

Approach #3 (Two Pointers) [Accepted]

  • Maintain two pointers pA and pB initialized at the head of A and B, respectively. Then let them both traverse through the lists, one node at a time.
  • When pA reaches the end of a list, then redirect it to the head of B (yes, B, that's right.); similarly when pB reaches the end of a list, redirect it the head of A.
  • If at any point pA meets pB, then pA/pB is the intersection node.
  • To see why the above trick would work, consider the following two lists: A = {1,3,5,7,9,11} and B = {2,4,9,11}, which are intersected at node '9'. Since B.length (=4) < A.length (=6), pB would reach the end of the merged list first, because pB traverses exactly 2 nodes less than pA does. By redirecting pB to head A, and pA to head B, we now ask pB to travel exactly 2 more nodes than pA would. So in the second iteration, they are guaranteed to reach the intersection node at the same time.
  • If two lists have intersection, then their last nodes must be the same one. So when pA/pB reaches the end of a list, record the last element of A/B respectively. If the two last elements are not the same one, then the two lists have no intersections.

Complexity Analysis

  • Time complexity : O(m+n)O(m+n).
  • Space complexity : O(1)O(1).

神奇?

贴一下Discuss里面的代码

ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) 
{
    ListNode *p1 = headA;
    ListNode *p2 = headB;
        
    if (p1 == NULL || p2 == NULL) return NULL;

    while (p1 != NULL && p2 != NULL && p1 != p2) {
        p1 = p1->next;
        p2 = p2->next;

        //
        // Any time they collide or reach end together without colliding 
        // then return any one of the pointers.
        //
        if (p1 == p2) return p1;

        //
        // If one of them reaches the end earlier then reuse it 
        // by moving it to the beginning of other list.
        // Once both of them go through reassigning, 
        // they will be equidistant from the collision point.
        //
        if (p1 == NULL) p1 = headB;
        if (p2 == NULL) p2 = headA;
    }
        
    return p1;
}

看了网上一些其他的思路,发现有用长度来做的,试了一波过了,但是像下面这种结构的似乎又说不太通???

1->3->4->5
2->3->4->6->7

还是也贴一下吧

/**
 * Definition for singly-linked list.
 * struct ListNode {
 *     int val;
 *     ListNode *next;
 *     ListNode(int x) : val(x), next(NULL) {}
 * };
 */
class Solution {
public:
    ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) {
        int alen = 0, blen = 0;
        ListNode *p = headA, *q = headB;
        while (p) {
            alen++;
            p = p->next;
        }
        while (q) {
            blen++;
            q = q->next;
        }
        p = headA, q = headB;
        if (alen > blen) {
            for (int i = 0; i < alen - blen; i++) {
                p = p->next;
            }
        } else if (blen > alen) {
            for (int i = 0; i < blen - alen; i++) {
                q = q->next;
            }
        }
        while (p) {
            if (p == q)  return p;
            p = p->next;
            q = q->next;
        }
        return NULL;
    }
};
posted @ 2018-03-25 21:52  酒晓语令  阅读(121)  评论(0编辑  收藏  举报